<?php

/**
 * @file
 * B14Entity views data provider.
 */

use Drupal\field\FieldStorageConfigInterface;

/**
 * Implements hook_views_data_alter().
 */
function entitylogic_views_data_alter(&$data) {
  foreach (\Drupal::entityTypeManager()->getDefinitions() as $type => $entity_type) {
    if (empty($data[$entity_type->getBaseTable()]) || !$entity_type->hasKey('id')) {
      continue;
    }

    $data[$entity_type->getBaseTable()]['entitylogic_method_call']['field'] = [
      'title' => t('Entitylogic: Method call'),
      'description' => t(''),
      'id' => 'entitylogic_method_call'
    ];
  }
}
